#! /bin/sh
if [ $# -lt 1 ] ; then 
	echo "Need an argument."
	exit 0
fi

HEADERS=`find . | perl -p -e "s/^\.\///" | egrep "(\.icc|\.hpp|\.h)$" | egrep "^(rounding_control|interval|fp_traits|ieee|bsd)"`
PREFIX=$1

for i in $HEADERS ; do
	DIR=`dirname $i`
	FILE=`basename $i`
	INSTDIR=${PREFIX}/include/${DIR}
	mkdir -p $INSTDIR
	cp -p $i ${INSTDIR}/${FILE}
done

LIBS=`find lib -type f`

for i in $LIBS ; do
	DIR=`dirname $i`
	FILE=`basename $i`
	INSTDIR=${PREFIX}/${DIR}
	mkdir -p $INSTDIR
	cp -p $i ${INSTDIR}/${FILE}
done

BINS=`find bin -type f`

for i in $BINS ; do
	DIR=`dirname $i`
	FILE=`basename $i`
	INSTDIR=${PREFIX}/${DIR}
	mkdir -p $INSTDIR
	cp -p $i ${INSTDIR}/${FILE}
done

cp -p lib/*.dll ${PREFIX}/bin/
